require "util"
--require "defines"

function get_key_for_invalid( t)
  for k,v in pairs(t) do
    if v.valid==false then return k
    end
    return nil
  end
end

function clean_rctanks()
  local curr = get_key_for_invalid(global.all_rctanks)
  while (curr ~= nil) do
    table.remove(global.all_rctanks, curr)
	curr = get_key_for_invalid(global.all_rctanks, nil)
  end
end

function enter_rctank(key, fromBase, playernumber)
  game.players[playernumber].driving = false
  clean_rctanks()
  if global.all_rctanks[key] ~= nil then
    global.rctank_player_x[playernumber] = game.players[playernumber].character.position.x
    global.rctank_player_y[playernumber] = game.players[playernumber].character.position.y
    game.players[playernumber].teleport{global.all_rctanks[key].position.x, global.all_rctanks[key].position.y}
    game.players[playernumber].driving = true
    global.inrctank[playernumber] = global.all_rctanks[key]
	global.rctank_player_base[playernumber] = fromBase
    show_rctank_showGui(playernumber, key)
  else
    game.players[playernumber].print("No RC tank found")
  end
end

function leave_rctank(playernumber)
  global.inrctank[playernumber] = 0
  game.players[playernumber].driving = false
  game.players[playernumber].teleport{global.rctank_player_x[playernumber], global.rctank_player_y[playernumber]}
  show_rctank_removeGui(playernumber)
end

function show_rctank_showGui(playernumber, key)
  game.players[playernumber].gui.top.add{type = "frame", caption = "RC Tank", name = "rctank_gui", direction = "horizontal"}
  game.players[playernumber].gui.top.rctank_gui.add{type = "label", caption = "Currently in RC Tank: ", name = "rctank_gui_label"}
  game.players[playernumber].gui.top.rctank_gui.add{type = "label", name = "rctank_gui_textfield"}
  game.players[playernumber].gui.top.rctank_gui.rctank_gui_textfield.caption = key
  game.players[playernumber].gui.top.rctank_gui.add{type = "button", caption = "-", name = "rctank_gui_decbutton"}
  game.players[playernumber].gui.top.rctank_gui.add{type = "button", caption = "+", name = "rctank_gui_incbutton"}
end

function show_rctank_removeGui(playernumber)
  game.players[playernumber].gui.top.rctank_gui.destroy()
end

script.on_init(function()
  global.inrctank = {0}
  global.rctank_player_x = {0}
  global.rctank_player_y = {0}
  global.rctank_player_base = {0}
  global.all_rctanks = {}
end)

script.on_event(defines.events.on_player_driving_changed_state, function(event)
  playernumber = event.player_index
  if game.players[playernumber].character and game.players[playernumber].character.vehicle and game.players[playernumber].vehicle.name == "rcbase" then
	enter_rctank(1, game.players[playernumber].character.vehicle, playernumber)
  else
    if global.inrctank[playernumber] ~= 0 then
	  leave_rctank(playernumber)
	end
  end
end)

script.on_event(defines.events.on_gui_click, function(event)
  playernumber = event.player_index
  if game.players[playernumber].gui.top.rctank_gui.rctank_gui_incbutton == event.element then
    newtank = game.players[playernumber].gui.top.rctank_gui.rctank_gui_textfield.caption +1
    if global.all_rctanks[newtank] ~= nil then
      leave_rctank(playernumber)
	  enter_rctank(newtank, global.rctank_player_base[playernumber], playernumber)
    end
  end

  if game.players[playernumber].gui.top.rctank_gui.rctank_gui_decbutton == event.element then
    newtank = game.players[playernumber].gui.top.rctank_gui.rctank_gui_textfield.caption -1
    if global.all_rctanks[newtank] ~= nil then
      leave_rctank(playernumber)
	  enter_rctank(newtank, global.rctank_player_base[playernumber], playernumber)
    end
  end
end)

script.on_event(defines.events.on_built_entity, function(event)
  if event.created_entity.name == "rctank" then
    table.insert(global.all_rctanks, event.created_entity)
  end
end)

script.on_event(defines.events.on_entity_died, function(event)
  for k,v in pairs(global.rctank_player_base) do
      if v==event.entity then return leave_rctank(k)
      end
  end
end)
